// remove the static text for search engines
document.getElementById("static").style.display = "none";

var tmpltr;		// kept outside for console inspection

// needed:		...
// consider:	more sensical nomenclature, smarter export w/ options, draggable panes
// bugs:		occasional stuck view on load, opera crappiness (maybe from Ace)

var change_data_mode;
var insert_text;
var insert_data_select_text;
var insert_custom_var;
var insert_custom_modal_var;
var fast_label_insert;
var labels = null;
var label;
var label_preview;
var qsql;
var qsql_item;
var qsql_type;
var qsql_name;
var qsql_func_insert;
var qsql_func_edit;
var check_stat;
$.fn.ready(function(){

	var $body = $("body");

	// browser fail
	if ((Modernizr.generatedcontent === false) || (Modernizr.localstorage === false)) {
		$("body").addClass("error").removeClass("loading").css({ width: "700px", margin: "20px auto" }).html("<h1>Dang.</h1><p>Looks like your browser didn't pass whatever random tests I decided were arbitrarily important:</p><pre>Modernizr: " + JSON.stringify(Modernizr).replace(/,/gi, ",\n    ").replace(/{/gi, "{\n    ").replace(/}/gi, "\n}") + "</pre><p>If you think this is in error or that I'm a dummy, contact me <a href=\"http://mynameistommy.com/\">here</a>. Otherwise, if you'd like to use this app, <a href='http://browsehappy.com/'>upgrade your browser</a>.</p>");
		return false;
	}

	tmpltr = {
		appname: "tmpltr",
		data: {},
		structure: "",
		style: "",
		editors: {},
		throttle: {
			// in case I add other throttlers later...
			render: undefined
		},
		$: {
			output: {
				body: $("#ifrOutput").contents().find("body"),
				head: $("#ifrOutput").contents().find("head")
			}
		},
		fn: {
			setData: function(_data) {
				tmpltr.$.data.removeClass("invalid");
				if (typeof _data === "string") {
					try {
						_data = $.parseJSON(_data);
					} catch (e1) {
						try {
							// Error parsing string data, attempting eval();
							_data = eval('(' + _data + ')');
						} catch (e2) {
							tmpltr.$.data.addClass("invalid");
							return false;
						}
					}
				}
				if (typeof _data === "object") {
					tmpltr.data = _data || tmpltr.data;
				}
			},
			setStructure: function(_structure) {
				tmpltr.structure = _structure || tmpltr.structure;
			},
			setStyle: function(_style) {
				tmpltr.style = _style || tmpltr.style;
			},
			// sets tmpltr props, fills editors, renders output
			useDataStructureStyle: function(settings) {
				if (typeof settings !== "object") { return false; }
				if (!settings.data || !settings.structure || !settings.style) { return false; }
				tmpltr.fn.setData(settings.data);
				tmpltr.fn.setStructure(settings.structure);
				tmpltr.editors.data.getSession().setValue(settings.data);
				tmpltr.editors.structure.getSession().setValue(settings.structure);
				return true;
			},
			renderOutput: function(sWhat){
				tmpltr.throttle.render = tmpltr.throttle.render || setTimeout(function(){
					sWhat = sWhat || "all";
					if ((sWhat === "html") || (sWhat === "all")) {
						tmpltr.$.output.body.html(
							Mustache.to_html(tmpltr.structure, tmpltr.data)
						);
					}
					if ((sWhat === "style") || (sWhat === "all")) {
						tmpltr.$.output.head.html(
							$("<style />").html(tmpltr.style)
						);
					}
					tmpltr.throttle.render = undefined;
				}, 500);
			},
			saveToLocal: function(){
				var obj = {
					data: tmpltr.editors.data.getSession().getValue(),
					structure: tmpltr.editors.structure.getSession().getValue()
				};
				localStorage.tmpltr = JSON.stringify(obj);
				return localStorage.tmpltr;
			},
			getLocal: function() {
				if (localStorage.tmpltr) {
					tmpltr.fn.useDataStructureStyle($.parseJSON(localStorage.tmpltr));
					return true;
				}
				return false;
			},
			getDefaults: function(){
				// probably not the cleanest way to do this...
				var iMilli = +new Date(), def = {};
				function areWeThereYet() {
					if (def.data && def.structure && def.style) {
						tmpltr.fn.useDataStructureStyle(def);
					}
				}
				return true;
			},
			reset: function(){
				delete localStorage.tmpltr;
				tmpltr.fn.getDefaults();
			},
			exportUri: function(){
				// will open a data URI in a new window, some browsers may cut it off...
				var sTitle = tmpltr.$.output.body.find("h1:first").text().trim();
				var sUrl = "data:text/html," +
				encodeURIComponent(
					(sTitle ? "<title>" + sTitle + "</title> " : "") +
					"<body>" + Mustache.to_html(tmpltr.structure, tmpltr.data) + "</body> " +
					"<style>" + tmpltr.style + "</style> " +
					"<form action='" + document.location.protocol + "//" + document.location.host + document.location.pathname + "' method='get' style='display:none'>" + 
						"<textarea name='data'>" + tmpltr.editors.data.getSession().getValue() + "</textarea> " +
						"<textarea name='structure'>" + tmpltr.editors.structure.getSession().getValue() + "</textarea> " +
					"</form> " +
					"<script src='" + document.location.protocol + "//" + document.location.host + document.location.pathname + "js/external.js'></script>"
				);
				window.open(sUrl);
			},
			getFromUrl: function(){
				var params = (function(){
					var qs = document.location.search.split("+").join(" ");
					var params = {}, tokens, re = /[?&]?([^=]+)=([^&]*)/g;
					while (tokens = re.exec(qs)) {
						params[decodeURIComponent(tokens[1])] = decodeURIComponent(tokens[2]);
					}
					return params;
				}());
				if (!params.data || !params.structure || !params.style) { return false; }
				tmpltr.fn.useDataStructureStyle(params);
				// clean up URL
				if (Modernizr.history) {
					history.replaceState(null, null, document.location.pathname);
				}
				return true;
			},
			fileDragOver: function (evt) {
				evt.stopPropagation();
				evt.preventDefault();
				$body.addClass("dropit");
			},
			fileDrop: function (evt) {
				evt.stopPropagation();
				evt.preventDefault();
				var files = evt.dataTransfer.files;
				for (var i = 0, f; f = files[i]; i++) {
					var reader = new FileReader();
					reader.onload = (function (theFile) {
						return function (e) {
							// clean this up!
							if (theFile.name.indexOf(".json") > -1) {
								tmpltr.editors.data.getSession().setValue(e.target.result);
								tmpltr.fn.setData(e.target.result);
							} else if (theFile.name.indexOf(".html") > -1) {
								tmpltr.editors.structure.getSession().setValue(e.target.result);
								tmpltr.fn.setStructure(e.target.result);
							}
						};
					})(f);
					reader.readAsText(f);
				}
				tmpltr.fn.renderOutput();
				tmpltr.fn.saveToLocal();
				$body.removeClass("dropit");
			}
		} // fn
	};

	// instantiate ace editors
	var editors = [
		{ name: "data", id: "preData", mode: require("ace/mode/json").Mode  },
		{ name: "structure", id: "preStructure", mode: require("ace/mode/html").Mode }
	];
	$.each(editors, function (iEditor, editor) {
		var $editor = tmpltr.$[editor.name] = $("#" + editor.id);
		var oEditor = ace.edit(editor.id);
		oEditor.setTheme("ace/theme/twilight");
		oEditor.getSession().setMode(new editor.mode);
		oEditor.renderer.setShowGutter(false);
		oEditor.renderer.setShowPrintMargin(false);
		oEditor.getSession().setUseSoftTabs(true);
		tmpltr.editors[editor.name] = oEditor;
		oEditor.on("focus", function(){ $editor.addClass("focus"); });
		oEditor.on("blur", function(){ $editor.removeClass("focus"); });
	});

	// attempt: fill from URL, get localStorage, or load defaults; then render
	if (!tmpltr.fn.getFromUrl()) {
		if (!tmpltr.fn.getLocal()) {
			tmpltr.fn.getDefaults();
		}
	}
	tmpltr.fn.renderOutput();

	// bind change events (not perfect: doesn't know paste, deleting)
	// could be abstracted more
	
	tmpltr.$.nav = $("#nav");

	// view switcher and nav links
	tmpltr.$.nav
		.on("click", ".inpView", function(){
			var $checked = tmpltr.$.nav.find("input:checked"), sVal = $checked.val();
			$body.attr("role", sVal);
			localStorage.view = sVal;
			$.each(tmpltr.editors, function(i, editor) {
				editor.resize();
			});
		})
		.on("click", "#aExport", function(){
			// tmpltr.fn.exportUri();
			tpl_save();
			return false;
		})
		.on("click", "#aRestore", function(){
			if (confirm("您确定要恢复为原模板数据吗？如果执行恢复，您临时编辑的数据都将无法恢复！")) {
				tmpltr.editors.structure.getSession().setValue(tpl.source_content);
			}
			return false;
		});

	// view in localStorage?
	if (localStorage.view) { $(".inpView[value='" + localStorage.view + "']").click(); }
	
	// handle files getting dragged into document
	if (Modernizr.file) {
		$body[0].addEventListener('dragover', tmpltr.fn.fileDragOver, false);
		$body[0].addEventListener('drop', tmpltr.fn.fileDrop, false);
		tmpltr.$.output.body[0].addEventListener('dragover', tmpltr.fn.fileDragOver, false);
		tmpltr.$.output.body[0].addEventListener('drop', tmpltr.fn.fileDrop, false);
	}

	// force links in output out of iframe
	tmpltr.$.output.body.on("click", "a", function() {
		var $a = $(this);
		if ($a.attr("href") && $a.attr("href") !== "#") {
			document.location = $a.attr("href");
		}
	});

	$body.removeClass("loading");
	
	// 不停更新链接在新窗口
	setInterval(function() {
		$("#ifrOutput").contents().find('a').attr("target", "_blank");
		$("#ifrOutput").contents().find('form').attr("target", "_blank");
	}, 500);
	
	// 加载窗口数据
	var update_frame = function() {
		var that = $("#ifrOutput");
		var scroll_top = that.contents().find('body').scrollTop();
		$("#ifrOutput").attr("src", tpl.url);
		try {
			that.ready(function() {
				setTimeout(function() {
					that.contents().find('body').scrollTop(scroll_top);
				}, 60);
			});
		} catch(e){}
	};
	update_frame();
	
	var tpl_sync = function() {
		var pos = tmpltr.editors.structure.getCursorPosition();
		tpl.content = tmpltr.editors.structure.getSession().getValue();
		$.post(tpl.func_sync,{file: tpl.file, encoding: tpl.encoding, server: tpl.server, row: pos.row, column: pos.column, tpl: tpl.content},
		function(data){
			if (data.result) {
				update_frame();
				change_save_stat(tpl.content == tpl.source_content);
			}
		},
		"json");
	};
	
	var tpl_save = function(no_alert) {
		var pos = tmpltr.editors.structure.getCursorPosition();
		var content = tmpltr.editors.structure.getSession().getValue();
		$.post(tpl.func_save,{file: tpl.file, encoding: tpl.encoding, server: tpl.server, tpl: content},
		function(data){
			if (data.result) {
				tpl.source_content = tpl.content = content;
				change_save_stat(true);
				update_frame();
				if (!no_alert) {
					alert("保存成功");
				}
			} else {
				alert("保存失败");
			}
		},
		"json");
	};
	
	var tpl_create_modal = function(sql, func) {
		$.post(tpl.func_create_modal,{sql: sql, encoding: tpl.encoding, server: tpl.server},
		function(data){
			func(data);
		},
		"json");
	};

	// 初始化数据
	/*
	tmpltr.editors.data.getSession().on('change', function() {
		tmpltr.fn.setData(tmpltr.editors.data.getSession().getValue());
		tmpltr.fn.renderOutput("html");
		tmpltr.fn.saveToLocal();
		update_frame();
	});
	*/
	var ReplaceAll = function(str, sptr, sptr1){
		while (str.indexOf(sptr) >= 0){
		   str = str.replace(sptr, sptr1);
		}
		return str;
	}
	var fmt_to_html = function(s) {
		s = ReplaceAll(s, "&lt;", "<");
		s = ReplaceAll(s, "&gt;", ">");
		return s;
	};
	var tick = 0;
	var decr_sync = function() {
		tick--;
		if (tick == 0) {
			tpl_sync();
		}
	};
	var incr_sync = function() {
		tick++;
		setTimeout(function() {
			decr_sync();
		}, (tpl && tpl["view_reload_time"])  ?  tpl.view_reload_time  :  500);
	};
	var loading = true;
	tpl.content = fmt_to_html(tpl.content);
	tpl.source_content = fmt_to_html(tpl.source_content);
	tmpltr.editors.structure.getSession().setValue(tpl.content);
	tmpltr.editors.data.getSession().setValue(fmt_to_html(tpl.init_data));
	tmpltr.editors.structure.getSession().on('change', function() {
		if (loading) return;
		tmpltr.fn.setStructure(tmpltr.editors.structure.getSession().getValue());
		tmpltr.fn.renderOutput("html");
		tmpltr.fn.saveToLocal();
		incr_sync();
	});
	// 加载标签列表
	var is_object = function(o) {
		return typeof(o) == "object"  &&  isNaN(o.length);
	};
	var is_array = function(o) {
		return typeof(o) == "object"  &&  !isNaN(o.length);
	};
	var blanks = function(level, lower) {
		var s = "";
		for (var i = 0; i < level; i++) {
			s += lower ? "\t" : "　";
		}
		return s;
	};
	/*
	// 插入列表默认变量
	var push_array_vars = function(level, list) {
		list.push({
			title: blanks(level) + "_奇偶行",
			key: k,
			type: 0
		});
	};
	*/
	var each_array_label = function(o, key, level, list) {
		if (o.length == 0) return;
		for (var k in o) {
			var v = o[k];
			var c = {
				title: blanks(level) + key,
				key: key,
				type: 1,
				level: level,
				children: []
			};
			if (is_array(v)) {
				each_array_label(v, k, 0, c.children);
				list.push(c);
				each_array_label(v, k, level, list);
			}
			else if (is_object(v)) {
				each_object_label(v, 0, c.children);
				list.push(c);
				each_object_label(v, level + 1, list);
			}
			break;
		}
	};
	var each_object_label = function(o, level, list) {
		if (!level) level = 0;
		if (!list) list = [];
		for (var k in o) {
			var v = o[k];
			if (is_array(v)) {
				each_array_label(v, k, level, list);
			}
			else if (is_object(v)) {
				var c = {
					title: blanks(level) + k,
					key: k,
					type: 1,
					level: level,
					children: []
				};
				each_object_label(v, 0, c.children);
				list.push(c);
				each_object_label(v, level + 1, list);
			}
			else
			{
				list.push({
					title: blanks(level) + k,
					key: k,
					level: level,
					type: 0
				});
			}
		}
		return list;
	};
	var fast_normal_ul = $(".fast-label-normal > ul");
	var selects = $("#labels"), selects_include = $("#tpl_files");
	selects.append("<option value=\"-1\">[插入包含文件]</option>");
	$(".labels-items").hide();
	if (tpl.modal  &&  tpl.modal != "") {
		var modal;
		eval("modal = " + tpl.modal);
		labels = each_object_label(modal);
		if (labels  &&  labels.length > 0) {
			for (var i in labels) {
				selects.append("<option value=\"" + i + "\">" + labels[i].title + "</option>");
				fast_normal_ul.append("<li onclick='fast_label_insert(" + i + ")'>" + labels[i].title + "</option>");
			}
		}
		var last_type = 0;
		label_preview = function(type) {
			if (!type) type = last_type;
			var out = "";
			var each_format = function(o) {
				if (!o) return "";
				var s = "";
				switch (o.type) {
					case 0:
						s += "{{" + o.key + "}} ";
						break;
					case 1:
						s += "{{#" + o.key + "}} ";
						if ($("#list-joh").is(":checked")) {
							s += "{{?_奇偶行=1}} {{/_奇偶行}} ";
						}
						if ($("#list-index").is(":checked")) {
							s += "{{_行序号}} ";
						}
						if (o.children) {
							for (var k in o.children) {
								s += each_format(o.children[k]);
							}
						}
						s += "{{/" + o.key + "}} ";
						break;
				}
				return s;
			};
			switch (type) {
				case 0:
					out = each_format(label);
					break;
				case 11:
					out = "{{?" + label.key + "}} 要显示的内容 {{/" + label.key + "}}";
					break;
				case 12:
					out = "{{?!" + label.key + "}} 要显示的内容 {{/" + label.key + "}}";
					break;
				case 13:
					out = "{{?" + label.key + "=0}} 等于0时显示内容 {{/" + label.key + "}}";
					break;
				case 14:
					out = "{{?" + label.key + "=\"真\"}} 等于真时显示内容 {{/" + label.key + "}}";
					break;
				case 15:
					out = "{{?" + label.key + "!=0}} 不等于0时显示内容 {{/" + label.key + "}}";
					break;
				case 16:
					out = "{{?" + label.key + "!=\"真\"}} 不等于真时显示内容 {{/" + label.key + "}}";
					break;
			}
			$(".labels-preview").val(out);
		};
		selects.change(function() {
			var pos = parseInt(selects.val());
			if (pos == -1) {
				$(".labels-items").hide();
				selects_include.show();
				selects_include.val("");
				$(".labels-preview").val("");
			}
			else
			{
				selects_include.hide();
				$(".labels-items").show();
				$("#out-mode").val("0");
				label = labels[pos];
				if (label.type == 1) {
					$(".labels-list").find(":checked").prop("checked", false);
				} else {
					$(".labels-list").hide();
				}
				label_preview(0);
			}
		});
	}
	if (tpl.tpl_files) {
		selects_include.append("<option value=\"\">--选择文件--</option>");
		for (var i in tpl.tpl_files) {
			var path = tpl.tpl_files[i];
			selects_include.append("<option value=\"" + path + "\">" + path + "</option>");
		}
		selects_include.change(function() {
			var path = selects_include.val();
			if (path  &&  path != "") {
				path = "{{> " + path + " }}";
			}
			$(".labels-preview").val(path);
		});
	}
	loading = false;
	
	change_data_mode = function(mode) {
		switch (mode) {
			case 0: 
				tmpltr.editors.data.getSession().setValue(fmt_to_html(tpl.modal));
				break;
			case 1: 
				tmpltr.editors.data.getSession().setValue(fmt_to_html(tpl.init_data));
				break;
			case 2: 
				tmpltr.editors.data.getSession().setValue(tpl.source_content);
				break;
		}
	};
	
	// 插入文本到当前代码
	insert_text = function(text) {
		if (text) {
			if (text.indexOf("\r\n") != -1) {
				var arr = text.split("\r\n");
				var blank = blanks(tmpltr.editors.data.getCursorPosition().column, true);
				var pos = 0;
				text = "";
				for (var i in arr) {
					if (pos++ == 0) {
						text += arr[i];
					} else {
						text += "\r\n" + blank + arr[i];
					}
				}
				
			}
			tmpltr.editors.structure.insert(text);
			tmpltr.editors.structure.focus();
		}
	};
	// 插入数据区域内容到当前代码
	insert_data_select_text = function() {
		var content = tmpltr.editors.data.getCopyText();
		if (!content || content.length == 0) {
			content = tmpltr.editors.data.session.getLine(tmpltr.editors.data.getCursorPosition().row);
		}
		if (content  &&  content.length > 0) {
			insert_text(content);
		}
	};
	
	// 更改保存状态
	var change_save_stat = function(saved) {
		$("#nav").removeClass("saved").removeClass("unsaved").addClass(saved ? "saved" : "unsaved");
	};
	// 加载初始值
	change_save_stat(tpl.content == tpl.source_content);
	var init_position = { row: tpl.row, column: tpl.column };
	tmpltr.editors.structure.focus();
	tmpltr.editors.structure.moveCursorToPosition(init_position);
	tmpltr.editors.structure.scrollToRow(init_position.row);
	
	// 添加F4全屏切换
	$(".sectInput > pre").keypress(function(event){
		if (event.ctrlKey)	// Ctrl
		{
			// 全屏
			if (event.which == 17)	// Q
			{
				if ($("#inpViewEdit").is(":checked")) {
					$("#inpViewSplit").click();
				} else {
					$("#inpViewEdit").click();
				}
			}
			else if (event.which == 10)	// M
			{
			// 保存
				tpl_save(true);
				event.preventDefault();
			}
		}
	});
	
	// 快速标签
	$(".fast-label").hover(function() {
		$(this).find("ul").show();
	}, function() {
		$(this).find("ul").hide();
	});
	fast_label_insert = function(id) {
		var o = labels[id];
		var s = "";
		var to_center = false;
		switch (o.type) {
			case 0:
				s += "{{" + o.key + "}}";
				break;
			case 1:
				s += "{{#" + o.key + "}}  {{/" + o.key + "}}";
				to_center = true;
				break;
		}
		var pos = tmpltr.editors.structure.getCursorPosition();
		insert_text(s);
		if (to_center) {
			pos.column += s.length / 2;
			tmpltr.editors.structure.moveCursorToPosition(pos);
		}
	};
	// 添加自定义变量
	insert_custom_var = function(title, head) {
		var _var = prompt(title, "");
		if (_var && _var.length > 0) {
			var s = "{{" + head + _var + "}}";
			insert_text(s);
		}
	};
	insert_custom_modal_var = function(is_list) {
		var _var = prompt("请输入模板数据变量名称", "");
		if (_var && _var.length > 0) {
			if (is_list) {
				var pos = tmpltr.editors.structure.getCursorPosition();
				var s = "{{#" +_var + "}}  {{/" +_var + "}}";
				insert_text(s);
				pos.column += s.length / 2;
				tmpltr.editors.structure.moveCursorToPosition(pos);
			}
			else
			{
				var s = "{{" + _var + "}}";
				insert_text(s);
			}
		}
	};
	// 快速SQL
	if (tpl.qsql_content  &&  tpl.qsql_content.length > 0) {
		qsql = JSON.parse(tpl.qsql_content);
	} else {
		qsql = {};
	}
	var last_type = "普通";
	var qsql_cur_step = 0;
	var qsql_init_title = "";
	var qsql_error = $("#qsql-error");
	var qsql_create_type;
	var qsql_modal = [];
	var qsql_sql;
	var qsql_fill_current_var;
	var qsql_fill_var_menu = function(){
		var menu = $(".qsql-var-menu");
		var html = "";
		if (labels  &&  labels.length > 0) {
			html += "<option value=\"\">====[标签]====</option>";
			for (var k in labels) {
				var o = labels[k];
				if (o.level == 0  &&  o.type == 0) {
					html += "<option value=\"" + o.key + "\">" + o.key + "</option>";
				}
			}
		}
		var title = ""
		var skip = false;
		$(".fast-label-vars > ul > li").each(function(i) {
			var li = $(this);
			if (li.hasClass("title")) {
				title = li.find("span > div").first().text();
				if (title.indexOf("网址") != -1) {
					skip = true;
					return;
				} else {
					skip = false;
				}
				html += "<option value=\"\">====[" + title + "]====</option>";
				if (title.indexOf("配置") != -1) {
					title = "_配置.";
				}
				else if (title.indexOf("COOKIE") != -1) {
					title = "_COOKIES.";
				}
				else if (title.indexOf("参数") != -1) {
					title = "_参数.";
				}
				else {
					title = "";
				}
			}
			else if (!skip)
			{
				html += "<option value=\"" + title + li.text() + "\">" + li.text() + "</option>";
			}
		});
		menu.html(html);
	};
	qsql_fill_var_menu();
	$("#qsql-fill-insert").click(function() {
		qsql_fill_current_var = $("#qsql-step-2 .qsql-var-menu").val();
		if (qsql_fill_current_var  &&  qsql_fill_current_var.length > 0) {
			var str = "@" + qsql_fill_current_var;
			var type = $("#qsql_fill_type").val();
			if (type  &&  type.length > 0) {
				str += ":" + type;
			}
			$("#qsql-sql-content").insertContent(str);
		}
	});
	var qsql_open = function(type, data, name) {
		qsql_type = type;
		qsql_item = data ? data : {
			"SQL":			"",
			"对象":			"",
			"类型":			last_type,
			"参数":			{	
				"分页尺寸":		"15",
				"当前分页":		"@_参数.分页"
			},
			"测试SQL":		"",
			"模型":			[],
			"标签组":		""
		};
		qsql_name = name ? name : "";
		last_type = qsql_item["类型"];
		qsql_create_type = (qsql_item["对象"]  &&  qsql_item["对象"].length > 0) ? "mapping" : "sql";
		qsql_init_title = ((type == 0  ?  "新建" : ("编辑 " + name)) + " 快速SQL");
		qsql_modal = [].concat(qsql_item["模型"]);
		qsql_sql = qsql_item["SQL"];
		qsql_set_title("");
		qsql_fill_current_var = "";
		
		// 初始化数据
		$("#qsql-name").val(qsql_name);
		$("#panel-psql-create-modal-sql > textarea").val(qsql_item["测试SQL"]);
		var $object_mapping = $("#panel-psql-create-modal > select");
		$object_mapping.html("");
		for (var k in tpl.object_mapping) {
			var oobj = tpl.object_mapping[k];
			var $oitem = $("<option value=\"" + k + "\">" + k + "</option>");
			$object_mapping.append($oitem);
		}
		$object_mapping.val(qsql_item["对象"]);
		if (qsql_create_type == 'sql') {
			$("#btn-create-modal-sql").click();
		} else {
			$("#btn-create-modal-mapping").click();
		}
		if (qsql_item["类型"] == "分页") {
			$("#btn-psql-page-used").click();
		} else {
			$("#btn-psql-page-none").click();
		}
		$("#qsql-step-2 > textarea").val(qsql_sql);
		$("#psql-page-size").val(qsql_item["参数"]["分页尺寸"]);
		$("#psql-page-current").val(qsql_item["参数"]["当前分页"]);
		
		// 打开窗口
		$("#modal-qsql").modal('show');
		qsql_step(0);
	};
	var qsql_next_step = function() {
		switch(qsql_cur_step) {
		case 0:
			if ($("#qsql-name").val().length == 0) {
				qsql_show_error("变量名称不能为空");
				return;
			}
			break;
		case 1:
			var do_next = function() {
				var s2sql = $("#qsql-step-2 > textarea").val();
				if (!s2sql  ||  s2sql.length == 0) {
					$("#qsql-step-2 > textarea").val($("#panel-psql-create-modal-sql > textarea").val());
				}
				qsql_step(++qsql_cur_step);
			};
			if (qsql_modal.length == 0) {
				qsql_create_modal(function(r) {
					if (r.result) {
						qsql_modal = [].concat(r.modal);
					} else {
						if (!confirm("无法创建返回结果模型：" + r.message + "，您确定要跳过？跳过后需要您在模板中手动填写SQL返回结果相关的标签！")) {
							return;
						}
					}
					do_next();
				});
			} else {
				do_next();
			}
			return;
		case 2:
			var sql = $("#qsql-sql-content").val();
			if (!sql  ||  sql.length == 0) {
				alert("SQL语句不能为空!");
				return;
			}
			break;
		case 3:
			break;
		}
		qsql_step(++qsql_cur_step);
	};
	var qsql_show_error = function(err) {
		qsql_error.find(".qsql-error-msg").text(err);
		qsql_error.show();
	};
	var qsql_set_title = function(title) {
		$("#qsql-title").text(((title && title.length > 0) ? (title + " - ") : "") + qsql_init_title);
	};
	var qsql_step = function(step) {
		var btn_finals = $(".qsql-btn-final");
		var btn_pre = $(".qsql-btn-pre");
		var btn_next = $(".qsql-btn-next");
		qsql_error.hide();
		$("#modal-qsql .modal-footer .btn").hide();
		$(".qsql-step").hide();
		
		switch(step) {
		case 0:
			qsql_set_title("");
			btn_next.show();
			break;
		case 1: {
			btn_pre.show();
			btn_next.show();
			qsql_set_title("创建返回结果模型");
			$(".qsql-btn-create-modal").show();
			$(".qsql-var-name").text("@" + $("#qsql-name").val());
			break;
		}
		case 2:
			btn_pre.show();
			btn_next.show();
			qsql_set_title("组装动态SQL");
			break;
		case 3:
			btn_pre.show();
			btn_finals.show();
			qsql_set_title("设置分页");
			break;
		}
		qsql_cur_step = step;
		var panel = $("#qsql-step-" + step);
		panel.show();
	};
	$(".qsql-btn-pre").click(function() {
		qsql_step(--qsql_cur_step);
	});
	$(".qsql-btn-next").click(function() {
		qsql_next_step();
	});
	// 保存
	$(".qsql-btn-final").click(function() {
		var name = $("#qsql-name").val();
		var page_size = $("#psql-page-size").val();
		var page_current = $("#psql-page-current").val();
		var used_page = $("#btn-psql-page-used").parent().hasClass("active");
		if (used_page) {
			if (!page_size || page_size.length == 0) {
				alert("分页大小不能为空！");
				return;
			}
			if (!page_current || page_current.length == 0) {
				alert("当前分页不能为空！");
				return;
			}
		}
		if (qsql_type == 0) {
			if (!qsql) {
				qsql = {};
			}
			if (qsql[name]) {
				if (!confirm("名称为“" + name + "”的快速SQL变量已经存在，您确定要覆盖吗？")) {
					return;
				}
			}
		}
		else if (name != qsql_name) {
			if (qsql[name]) {
				if (!confirm("名称为“" + name + "”的快速SQL变量已经存在，您确定要覆盖吗？")) {
					return;
				}
			}
			delete qsql[qsql_name];
		}
		qsql_item["SQL"] = $("#qsql-step-2 > textarea").val();
		qsql_item["类型"] = used_page ? "分页" : "普通";
		qsql_item["测试SQL"] = $("#panel-psql-create-modal-sql > textarea").val();
		if ($("#btn-create-modal-sql").parent().hasClass("active")) {
			qsql_item["对象"] = "";
		} else {
			qsql_item["对象"] = $("#panel-psql-create-modal > select").val();
		}
		qsql_item["模型"] = qsql_modal;
		qsql_item["参数"]["分页尺寸"] = page_size ? page_size : "";
		qsql_item["参数"]["当前分页"] = page_current ? page_current : "";
		// 创建标签组
		var tags = "";
		var model_tags = "";
		if (qsql_modal) {
			for (var k in qsql_modal) {
				if (model_tags.length > 0) {
					model_tags += " ";
				}
				model_tags += "{{" + qsql_modal[k] + "}}";
			}
		}
		// 分页
		if (used_page) {
			tags += "{{#@" + name + "}}\r\n";
			tags += "	{{总数}}\r\n";
			tags += "	{{分页大小}}\r\n";
			tags += "	{{分页总数}}\r\n";
			tags += "	{{当前页}}\r\n";
			tags += "	{{上页}}\r\n";
			tags += "	{{下页}}\r\n";
			tags += "	{{#分页列表}}\r\n";
			tags += "		{{分页}}\r\n";
			tags += "		{{?是否当前页}} {{/是否当前页}}\r\n";
			tags += "	{{/分页列表}}\r\n";
			tags += "	{{#分页内容}}\r\n";
			tags += "		" + model_tags + "\r\n";
			tags += "	{{/分页内容}}\r\n";
			tags += "{{/@" + name + "}}\r\n";
		} else {
			tags += "{{#@" + name + "}}\r\n";
			tags += "	" + model_tags + "\r\n";
			tags += "{{/@" + name + "}}\r\n";
		}
		qsql_item["标签组"] = tags;
		qsql[name] = qsql_item;
		qsql_item = null;
		var json = JSON.stringify(qsql);
		$.post(tpl.func_save,{file: tpl.qsql_file, encoding: tpl.encoding, server: tpl.server, tpl: json},
			function(data){
				if (data.result) {
					qsql_reload();
					$("#modal-qsql").modal('hide');
				} else {
					alert("保存失败");
				}
			},
			"json");
	});
	var qsql_create_modal = function(func) {
		var err = function(msg) {
			func({
				result: false,
				message: msg
			});
		};
		var succ = function(modal) {
			func({
				result: true,
				modal: modal
			});
		};
		if ($("#btn-create-modal-sql").parent().hasClass("active")) {
			var sql = $("#panel-psql-create-modal-sql > textarea").val();
			if (!sql  ||  sql.length == 0) {
				return err("测试SQL不能为空");
			}
			tpl_create_modal(sql, function(r) {
				if (r.result) {
					return succ(r.datas);
				} else {
					return err(r.message);
				}
			});
		} else {
			var name = $("#panel-psql-create-modal > select").val();
			if (name  &&  name.length > 0  &&  tpl.object_mapping[name]) {
				return succ(tpl.object_mapping[name]);
			} else {
				return err("请选择映射对象!");
			}
		}
	};
	$(".qsql-btn-create-modal").click(function() {
		qsql_create_modal(function(r) {
			if (r.result) {
				qsql_modal = [].concat(r.modal);
				qsql_next_step();
			} else {
				alert("创建失败:" + r.message);
			}
		});
	});
	tpl.object_mapping = JSON.parse(tpl.object_mapping_str);
	
	var qsql_name_array = [];
	// 添加快速SQL函数
	qsql_func_insert = function(pos) {
		var key = qsql_name_array[pos];
		insert_text(qsql[key]["标签组"]);
	};
	// 修改快速SQL函数
	qsql_func_edit = function(pos) {
		var key = qsql_name_array[pos];
		qsql_open(1, qsql[key], key);
	};
	// 加载快速SQL列表
	var qsql_reload = function() {
		qsql_name_array = [];
		var that = $(".quick-sql");
		that.find("li.normal").remove();
		var pos = 0;
		for (var k in qsql) {
			qsql_name_array.push(k);
			var o = qsql[k];
			var name = "@" + k + (o.type == "分页" ? (":" + o.type) : "");
			var dom = $($(".qsql-tpl").html());
			dom.find(".qkey").html(name);
			dom.find(".qused").attr("onclick", "qsql_func_insert(" + pos + ")");
			dom.find(".qedit").attr("onclick", "qsql_func_edit(" + pos + ")");
			that.append(dom);
			pos++;
		}
	};
	qsql_reload();
	$("#qsql-new").click(function() {
		qsql_open(0);
	});
	
	// 状态切换检测
	if (typeof(tpl["check_stat"]) != "undefined") {
		check_stat = tpl["check_stat"];
	}
});
$(function() {
	/*  在textarea处插入文本--Start */
	(function($) {
		$.fn
			.extend({
				insertContent : function(myValue, t) {
					var $t = $(this)[0];
					if (document.selection) { // ie
						this.focus();
						var sel = document.selection.createRange();
						sel.text = myValue;
						this.focus();
						sel.moveStart('character', -l);
						var wee = sel.text.length;
						if (arguments.length == 2) {
							var l = $t.value.length;
							sel.moveEnd("character", wee + t);
							t <= 0 ? sel.moveStart("character", wee - 2 * t
									- myValue.length) : sel.moveStart(
									"character", wee - t - myValue.length);
							sel.select();
						}
					} else if ($t.selectionStart
							|| $t.selectionStart == '0') {
						var startPos = $t.selectionStart;
						var endPos = $t.selectionEnd;
						var scrollTop = $t.scrollTop;
						$t.value = $t.value.substring(0, startPos)
								+ myValue
								+ $t.value.substring(endPos,
										$t.value.length);
						this.focus();
						$t.selectionStart = startPos + myValue.length;
						$t.selectionEnd = startPos + myValue.length;
						$t.scrollTop = scrollTop;
						if (arguments.length == 2) {
							$t.setSelectionRange(startPos - t,
									$t.selectionEnd + t);
							this.focus();
						}
					} else {
						this.value += myValue;
						this.focus();
					}
				}
			})
	})(jQuery);
	/* 在textarea处插入文本--Ending */
});